// MtuOpenCVsample.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include "opencv2/opencv.hpp"
#include "mtu.h"
using namespace cv;

#define CAMERAID	(0)
#define WIDTH		(1280)
#define HEIGHT		(720)

int main()
{
	namedWindow("CameraView", CV_WINDOW_AUTOSIZE);
	if (MtuOpen(CAMERAID, WIDTH, HEIGHT, 60, "YUY2") != 0){
		return 1;		// G[
	}
	int size = MtuGetBufferSize(CAMERAID);			// 摜f[^TCY擾
	unsigned char *buffer = new unsigned char[size];	// 摜f[^ۑ

	for (;;) {
		if (MtuReceiveImage(CAMERAID, buffer) == false) {	// 摜f[^擾
			continue;
		}
		Mat bayer16BitMat(HEIGHT, WIDTH, CV_16UC1, buffer); // 摜ްOpenCVްɕϊ
		Mat bayer8BitMat = bayer16BitMat.clone();       // 8bit xC[zf[^
		bayer8BitMat.convertTo(bayer8BitMat, CV_8UC1, 0.249267); // 16bit8bit޲ԕϊ
		Mat rgb8BitMat(HEIGHT, WIDTH, CV_8UC3);		// 8bit RGBzf[^
		cvtColor(bayer8BitMat, rgb8BitMat, CV_BayerBG2BGR); // 8bit޲԰8bitRGBɕϊ
		imshow("CameraView", rgb8BitMat);	    // \
		if ((char)waitKey(10) == 27) {		// ESCL[͗L
			break;
		}
	}
	cvDestroyWindow("CameraView");
	MtuClose(CAMERAID);
	delete buffer;
    return 0;
}

