// xC[ RAW 10bit  RGB32(RGBe8bit)ϊ֐
// xC[`
// width    
// height   
// src      ϊ
// dst      ϊ
// ӁFsrc width*height*2(unsigned short)̃TCYKv
//       dst width*height*4̃TCYKv
void bayerTo8RGB(int width, int height, unsigned short src[], unsigned char dst[])
{
    int h, w;
    int p11, p12, p13;
    int p21, p22, p23;
    int p31, p32, p33;
    int dst_cnt;

    for (h = 0; h < height; h++)
    {
        for (w = 0; w < width; w++)
        {
            // zʒuvZ
            int a, b, c, d;
            if (h == 0)
            {
                a = -1;
            }
            else
            {
                a = 1;
            }
            if (h == (height - 1))
            {
                b = -1;
            }
            else
            {
                b = 1;
            }
            if (w == 0)
            {
                c = -1;
            }
            else
            {
                c = 1;
            }
            if (w == (width - 1))
            {
                d = -1;
            }
            else
            {
                d = 1;
            }
            p11 = (((h - a) * width) + (w - c));    //       (-1,-1)
            p12 = (((h - a) * width) + (w));        //       (0 ,-1)
            p13 = (((h - a) * width) + (w + d));    //       (+1,-1)

            p21 = (((h)* width) + (w - c));         //        (-1,0)
            p22 = (((h)* width) + (w));             //  (0 ,0)
            p23 = (((h)* width) + (w + d));         //        (+1,0)

            p31 = (((h + b) * width) + (w - c));    //       (-1,+1)
            p32 = (((h + b) * width) + (w));        //       (0 ,+1)
            p33 = (((h + b) * width) + (w + d));    //       (+1,+1)

            dst_cnt = (h * width * 4) + (w * 4);
            unsigned char *dst1 = &dst[dst_cnt];

            if (((h & 0x01) == 0) && ((w & 0x01) == 1))
            {
                // Gb
                *(dst1 + 0) = (unsigned char)((src[p12] + src[p32]) >> 3);  // R
                *(dst1 + 1) = (unsigned char)((src[p22]) >> 2);             // G
                *(dst1 + 2) = (unsigned char)((src[p21] + src[p23]) >> 3);  // B
            }
            else if (((h & 0x01) == 0) && ((w & 0x01) == 0))
            {
                // B
                *(dst1 + 0) = (unsigned char)((src[p11] + src[p13] + src[p31] + src[p33]) >> 4);  // R
                *(dst1 + 1) = (unsigned char)((src[p21] + src[p23]) >> 3);                        // G
                *(dst1 + 2) = (unsigned char)((src[p22]) >> 2);                                   // B
            }
            else if (((h & 0x01) == 1) && ((w & 0x01) == 1))
            {
                // R
                *(dst1 + 0) = (unsigned char)((src[p22]) >> 2);                                   // R
                *(dst1 + 1) = (unsigned char)((src[p21] + src[p23]) >> 3);                        // G
                *(dst1 + 2) = (unsigned char)((src[p11] + src[p13] + src[p31] + src[p33]) >> 4);  // B
            }
            else if (((h & 0x01) == 1) && ((w & 0x01) == 0))
            {
                // Gr
                *(dst1 + 0) = (unsigned char)((src[p21] + src[p23]) >> 3);  // R
                *(dst1 + 1) = (unsigned char)((src[p22]) >> 2);             // G
                *(dst1 + 2) = (unsigned char)((src[p12] + src[p32]) >> 3);  // B
            }
            *(dst1 + 3) = 0;
        }
    }
}
